import uoc.ei.tads.*;

/**
 * Ejercicio práctico sobre operaciones básicas de las colas (FIFO) y
 * de las pilas (LIFO).
 *
 * @author  Equipo docente.
 *          Estructura de la Información,
 *          Universitat Oberta de Catalunya (UOC)
 * @version Febrero 2013
 * @since  1.5
 */
public class EjercicioPractico1
{
   /** Salto de línea de la plataforma. */
   public static final String LS = System.getProperty("line.separator");

   /** Capacidad máxima de la secuencia. */
   public static final int CAPACITY = 9;

   /** Método principal, que ejecuta el ejecicio. */
   public static void main (String[] args)
   {
      System.out.println(LS +
         "Crea una cola acotada para " + CAPACITY + " elementos " +
         "y encola los digitos del '0' al '" + (CAPACITY-1) + "'" + LS);
      Cola<Character> cola = new ColaVectorImpl<Character>(CAPACITY);

      System.out.println(
         "Crea una pila acotada para " + CAPACITY + " elementos " +
         "y apila los digitos del '0' al '" + (CAPACITY-1) + "'" + LS);
      Pila<Character> pila = new PilaVectorImpl<Character>(CAPACITY);

      // almacena los dígitos del '0' al '8'
      for (char c = '0'; c < '9'; c++)
      {
         cola.encolar(Character.valueOf(c));
         pila.apilar(Character.valueOf(c));
      }

      System.out.print("Desencola todos los elementos: ");
      while (! cola.estaVacio()) System.out.print(cola.desencolar() + " ");
      System.out.println(LS);

      System.out.print("Desapila todos los elementos:  ");
      while (! pila.estaVacio()) System.out.print(pila.desapilar() + " ");
      System.out.println();
   }
}
